// My_whit class DECLARATION and IMPLEMENTATION
// software by Gianluca Aglieri Rinella
// Doctoral Student at CERN
// European Organization for Nuclear Research
//
// with permission to use it freely but reproducing this comment
// including when reused, follow GPL and I will be happy
//
// last modified on 01/09/05
//
// C++ class to store and work with HPD weighted hits
// 
// class My_whit inherits from My_hit, so check out the My_hit.C file
// for documentation on what you can do with a My_hit and then with a My_whit
//
// class My_hit is a simple but useful hit description class
// it stores a hit by its row and col coordinates
// wrapped together
//
// class My_whit adds the possibility to store a weight to a hit,
// i.e. the number of times the pixel was hit.
//
// to use these classes include this file from your source
// this software is using only very standard C++ classes and include files
//

#ifndef MY_WHIT
#define MY_WHIT

#include "./My_hit.C" // it needs My_hit.C, this class is inheriting...
#include <iostream>

// class My_whit 
//
// My_whit is a My_hit 
// My_whit extends My_hit adding an integer weight to the hit
//
// Interface
//
// There is a NEW COMPULSORY constructor
//
// My_whit (int row, int col,unsigned int weight);
//
// Largest part of interface is inherited from My_hit:
//
// inline int GetRow();
// inline int GetCol();
// inline int SetRow(int row);
// inline int SetCol(int col);
// bool IsAdiacentTo (My_hit &hit);
// bool IsTheSame (My_hit& hit);
//
// bool IsAdiacentOnSameRow (My_hit &hit);
// bool IsAdiacentOnSameColumn (My_hit &hit);
// bool operator ==  (My_hit& hit);  added on 1/09/2005, does the same
// thing of IsTheSame member function
//
// The extension to My_hit interface, just the proper getter and setter
//
// inline unsigned int GetWeight() { return weight; }
// inline int SetWeight(unsigned int new_weight) {

class My_whit : public My_hit {
  // comment this out, data members coming from My_hit
  //int row_num;
  // int col_num;
  unsigned int weight;

public : 

  // constructor: compulsory to provide coordinates and weigth
  // assignes row, col and weight. Latter is optional
  My_whit (int row, int col, unsigned int new_weight = 1) : My_hit(row,col) {
  weight = new_weight;
  }

  // just add getter and setter for the new variable
  inline unsigned int GetWeight() { return weight; }
  inline int SetWeight(unsigned int new_weight) {
    weight = new_weight; return weight; }

};
// end of Class My_whit


// My_whit_tools::Eliminate_twins
// is an auxiliar method to filter out hits present twice into a My_whit
// list,
// WATCH OUT: different namespace for My_hit or My_whit vectors!! 
// This is an auxiliar method to filter out hits present twice into a hit
// list,
// i.e. it searches into a vector of My_whit if there are hits with
// same coordinates and eliminates redundant copies.
// It is not strictly a My_whit member method, it does not act on an object, but requires 
// a list as argument
// To use the method one has to call it with syntax:
// My_whit_tools::Eliminate_twins(hit_vector);
// or after a 
// using namespace My_whit_tools directive
//
namespace My_whit_tools {

void Eliminate_twins(vector<My_whit > &hit_list) {

  if (hit_list.size()>1) { // only if there are at least two hits in
                           // the list.. 
 
    vector<My_whit >::iterator hit_list_iter1, hit_list_iter2;

    for (hit_list_iter1=hit_list.begin();
	 hit_list_iter1<hit_list.end(); hit_list_iter1++) {

      for (hit_list_iter2=hit_list_iter1+1;
	   hit_list_iter2<hit_list.end(); hit_list_iter2++) {

    if( (*hit_list_iter1).IsTheSame((*hit_list_iter2)) == true) { // is the same 
      std::cout << "My_whit_tools::Eliminate_twins: found twin whit" << std::endl;
      // add to the first hit the weight of the second
      (*hit_list_iter1).SetWeight( (*hit_list_iter1).GetWeight() +
				   (*hit_list_iter2).GetWeight() );
      // and now kick the second element out from the list
      hit_list.erase(hit_list_iter2, hit_list_iter2+1);
    }

      }
    }
  }
}


  /* void Eliminate_twins(vector<My_whit > &hit_list) {
  if (hit_list.size()>1) { // only if there are at least two hits in
                           // the list.. 
  bool found = false;
  for (int i = hit_list.size()-1; i>0 ; i--) { //scan from last to first
    found = false; // not yet found a twin
  for (int j = i-1; j>=0 ; j--) { // scan from previous to first
    if(hit_list[i].IsTheSame(hit_list[j])==true) { // is the same 
	found = true;
      }
    }
    if (found==true) {
      hit_list.pop_back(); // ok, we got a twin...
     // remove last element, it had a twin in the list
    }
  }
  }


} // end of method Eliminate_twins
  */


}


#endif
